﻿namespace EonaCat.HID
{
    public class Attributes
    {
        // This file is part of the EonaCat project(s) which is released under the Apache License.
        // See the LICENSE file or go to https://EonaCat.com/License for full license details.

        internal Attributes(NativeMethods.HIDD_ATTRIBUTES attributes)
        {
            VendorId = attributes.VendorID;
            ProductId = attributes.ProductID;
            Version = attributes.VersionNumber;

            VendorIdHex = "0x" + attributes.VendorID.ToString("X4");
            ProductIdHex = "0x" + attributes.ProductID.ToString("X4");
        }

        public int VendorId { get; private set; }
        public int ProductId { get; private set; }
        public int Version { get; private set; }
        public string VendorIdHex { get; set; }
        public string ProductIdHex { get; set; }
    }
}