﻿using System.Collections.Generic;
using System.Linq;

namespace EonaCat.HID
{
    // This file is part of the EonaCat project(s) which is released under the Apache License.
    // See the LICENSE file or go to https://EonaCat.com/License for full license details.
    public class Enumerator : IEnumerator
    {
        public bool IsConnected(string devicePath)
        {
            return Devices.IsConnected(devicePath);
        }

        public IDevice GetDevice(string devicePath)
        {
            return Devices.GetDevice(devicePath);
        }

        public IEnumerable<IDevice> Enumerate()
        {
            return Devices.Enumerate().Select(x => x as IDevice);
        }

        public IEnumerable<IDevice> Enumerate(string devicePath)
        {
            return Devices.Enumerate(devicePath).Select(x => x as IDevice);
        }

        public IEnumerable<IDevice> Enumerate(int vendorId, params int[] productIds)
        {
            return Devices.Enumerate(vendorId, productIds).Select(x => x as IDevice);
        }

        public IEnumerable<IDevice> Enumerate(int vendorId)
        {
            return Devices.Enumerate(vendorId).Select(x => x as IDevice);
        }
    }
}