﻿using System.Threading.Tasks;

namespace EonaCat.HID
{
    // This file is part of the EonaCat project(s) which is released under the Apache License.
    // See the LICENSE file or go to https://EonaCat.com/License for full license details.
    public class ReadDevice : Device
    {
        internal ReadDevice(string devicePath, string description = null)
            : base(devicePath, description) { }

        public DeviceData FastRead(int timeout = 0)
        {
            try
            {
                return ReadData(timeout);
            }
            catch
            {
                return new DeviceData(DeviceData.ReadStatus.ReadError);
            }
        }

        public async Task<DeviceData> FastReadAsync(int timeout = 0)
        {
            return await Task.Run(() => FastRead(timeout));
        }

        public Report FastReadReport(int timeout = 0)
        {
            return new Report(Capabilities.InputReportByteLength, FastRead(timeout));
        }

        public async Task<Report> FastReadReportAsync(int timeout = 0)
        {
            return await Task.Run(() => FastReadReport(timeout));
        }
    }
}